#include "stdafx.h"
#include <malloc.h>

typedef unsigned short WORD;
typedef unsigned long DWORD;
typedef unsigned char BYTE;
typedef long LONG;

typedef struct _WinBMPFileHeader
{
	WORD   FileType;     /* File type, always 4D42h ("BM") */
	DWORD  FileSize;     /* Size of the file in bytes */
	WORD   Reserved1;    /* Always 0 */
	WORD   Reserved2;    /* Always 0 */
	DWORD  BitmapOffset; /* Starting position of image data in bytes */
} WINBMPFILEHEADER;

typedef struct _Win3xBitmapHeader
{
	DWORD Size;            /* Size of this header in bytes */
	LONG  Width;           /* Image width in pixels */
	LONG  Height;          /* Image height in pixels */
	WORD  Planes;          /* Number of color planes */
	WORD  BitsPerPixel;    /* Number of bits per pixel */
	/* Fields added for Windows 3.x follow this line */
	DWORD Compression;     /* Compression methods used */
	DWORD SizeOfBitmap;    /* Size of bitmap in bytes */
	LONG  HorzResolution;  /* Horizontal resolution in pixels per meter */
	LONG  VertResolution;  /* Vertical resolution in pixels per meter */
	DWORD ColorsUsed;      /* Number of colors in the image */
	DWORD ColorsImportant; /* Minimum number of important colors */
} WIN3XBITMAPHEADER;


void VypisPamet(void *adresa, unsigned int delka) {
	unsigned char *u;

	int x = 0;
	u = (unsigned char *)adresa;
	puts("**************************");
	printf("MEMORY    ADRESS: %p SIZE: %d %04X(HEX)\n", adresa, delka, delka);
	for (; delka; delka--, u++)
	{

		printf("%02X ", *u);
		x++;
		if (x >= 8){
			putchar('\n');
			x = 0;
		}
	}
	puts("");
}

int _tmain(int argc, _TCHAR* argv[])
{
	//	unsigned char uc[100];
	WINBMPFILEHEADER h;
	WIN3XBITMAPHEADER head;
	FILE *f;
	int delka,x1=0,i;
	unsigned char *buf,*pom;
	unsigned char bajt;
	//	f = fopen("intelww4.bmp", "rb"); //rb otevrit jako binarni
	fopen_s(&f, "intelww4.bmp", "rb");
	if (f == NULL)
	{
		puts("Chyba,nepodarilo se otevrit.\n");
		return 1;
	}
	fread(&h, sizeof(h), 1, f);

	VypisPamet(&h, sizeof(h));
	printf("HEADER: %c%c %d %04X\n", h.FileType % 256, h.FileType >> 8, h.FileType);
	printf("SIZE:   %d %08X(hex)\n", h.FileSize, h.FileSize);
	printf("OFFSET: %d %08X(hex)\n", h.BitmapOffset, h.BitmapOffset);
	fread(&head, 1, sizeof(head), f);
	VypisPamet(&head, sizeof(head));
	fseek(f, h.BitmapOffset, SEEK_SET);
	delka = head.Height*head.Width / 8;
	buf = (unsigned char*)malloc(delka);
	pom = buf;
	fread(buf, delka, 1, f);
	pom = pom + (delka - (head.Width / 8));
	for (; delka; delka--, pom++){
		
		bajt = *pom;
		for (i = 0; i <= 7;i++) {
			if (bajt&(0x80 >>i)) printf("%c",2);
			else printf(" ");
		}
		x1++;
		if (x1 == head.Width/8) {
			printf("\n");
			x1 = 0;
			pom = pom - 2*head.Width / 8;
		}
		

	}
	free(buf);
	fclose(f);
	return 0;
}
