// domaci_ukol_Fejfarova.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include "stdlib.h"
#pragma pack(2)
typedef unsigned char byte;
typedef unsigned short word;
typedef unsigned int dword;

typedef struct BmpFileHeader_s
{
	word FileType; 
	dword FileSize; 
	word Reserved1;  
	word Reserved2; 
	dword BitmapOffset; 
} BmpFileHeader;


typedef struct BitmapHeader_s /*viz cviceni PEL*/
{
	dword Size;
	dword Width;
	dword Height;
	word Planes;
	word BitsPerPixel;
	dword Compression;
	dword SizeOfBitmap;
	dword HorzResolution;
	dword VertResolution;
	dword ColorsUsed;
	dword ColorsImportant;
} BitmapHeader;

void TiskPameti(unsigned char * addr_p, unsigned int length) 
{
	unsigned int i; 
	if ((addr_p != NULL) && (length > 0))
	{
		printf("Pamet zacina na 0x%08X: of length %d bytes\n", (addr_p), length);
		for (i = 0; i < length; i++)
		{
			printf("%02X ", *(addr_p + i));
			if (((i + 1) % 16) == 0)
				printf("\n");
		}
	}
}

int _tmain(int argc, _TCHAR* argv[])
{
	FILE *fr;
	BmpFileHeader hs1; 
	BitmapHeader hs2; 
	byte *pole; 
	int velPole = 0; 
	int maskovani = 0x80; 
	byte *indikatorpol; 
	unsigned int radek; 
	unsigned int polRad; 
	int narust;

	if (0 != (fopen_s(&fr, "C:\\Users\\vojta\\Documents\\Visual Studio 2013\\Projects\\domaci_ukol_Fejfarova\\Debug\\intelww4.bmp", "rb")))
	{
		printf("Soubor neni mozne otevrit.\n"); 
		printf("\nZkontrolujte soubor.\n");
		return -1;
	}

	fread(&hs1, sizeof(BmpFileHeader), 1, fr);
	fread(&hs2, sizeof(BitmapHeader), 1, fr);
	velPole = hs2.Height * hs2.Width / 8;
	pole = (byte*)malloc(velPole);
	if (pole == NULL)
	{
		printf("Pamet neni dostatecna\n");
		printf("Program musi byt ukoncen\n");

		return -1;
	}

	fseek(fr, hs1.BitmapOffset, 0); 
	fread(pole, velPole, 1, fr);

	for (radek = 1; radek <= hs2.Height; radek++)
	{
		narust = (hs2.Width / 8)*(hs2.Height - radek); 
		indikatorpol = pole + narust;

		for (polRad = 0; polRad < hs2.Width; polRad++)
		{
			if (*indikatorpol & maskovani)
				printf("%c", '@');
			else
				printf("%c", ' ');

			maskovani >>= 1;
			
			if (maskovani == 0)
			{
				indikatorpol++; 
				maskovani = 0x80;
			}
		}

		printf("\n");
	}

	free((void *)pole);
	if (0 != (fclose(fr)))
	{
		printf("Soubor neuzavren\n"); 
		printf("Provedte kontrolu\n");
		return -1;
	}

	return 0;
}