// ukol1_v1.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"

#include <stdlib.h> //kvli funkci malloc a free

#define SOUBOR "intelww4.bmp"

#pragma pack(2)	//nastaven zarovnani pameti

typedef unsigned char byte; // 8-bitu
typedef unsigned short word; // 16-bitu
typedef unsigned int dword; // 32-bitu

typedef struct BmpFileHeader_s //def struktury prevzato ze cviceni
{
	word FileType; /* File type, always 4D42h ("BM") */
	dword FileSize; /* Size of the file in bytes */
	word Reserved1; /* Always 0 */
	word Reserved2; /* Always 0 */
	dword BitmapOffset; /* Starting position of image data in bytes */
} BmpFileHeader;

typedef struct BitmapHeader_s //def struktury prevzato ze cviceni
{
	dword Size; /* Size of this header in bytes */
	dword Width; /* Image width in pixels */
	dword Height; /* Image height in pixels */
	word Planes; /* Number of color planes */
	word BitsPerPixel; /* Number of bits per pixel */
	dword Compression; /* Compression methods used */
	dword SizeOfBitmap; /* Size of bitmap in bytes */
	dword HorzResolution; /* Horizontal resolution in pixels per meter */
	dword VertResolution; /* Vertical resolution in pixels per meter */
	dword ColorsUsed; /* Number of colors in the image */
	dword ColorsImportant; /* Minimum number of important colors */
} BitmapHeader;

void PrintMemory(unsigned char * addr_p, unsigned int length) //fce na tisk pameti
{ 
	unsigned int i; 
	if ((addr_p != NULL) && (length > 0)) //test jestli neni pamet nula
	{ 
		printf("Memory starting at 0x%08X: of length %d bytes\n\n", (addr_p), length); 
		for (i = 0; i < length; i++) 
		{ 
			printf("%02X ", *(addr_p + i));
			if (((i + 1) % 16) == 0) //odradkovani po 16 bitech
				printf("\n");
		} 
	}
}

int _tmain(int argc, _TCHAR* argv[])
{
	//unsigned char *pointerHeader2;
	//unsigned char *pointerHeader3;
	FILE *fr;
	BmpFileHeader fileHeader2;
	BitmapHeader fileHeader3;
	byte *pole;
	int velikostPole = 0;
	int maska = 0x80;
	byte *ukazatelPole;
	int radek;
	unsigned int poziceRadek;
	int prirustek;

	if (0 != (fopen_s(&fr, SOUBOR, "rb")))
	{
		printf("Chyba soubor nelze otevrit...Program bude ukoncen");
		(void)getchar();
		return -1;
	}

	//pointerHeader2 = (unsigned char*)&fileHeader2;
	//fread(pointerHeader2 , sizeof(BmpFileHeader), 1, fr);
	fread(&fileHeader2, sizeof(BmpFileHeader), 1, fr);

	//pointerHeader3 = (unsigned char*)&fileHeader3;
	fread(&fileHeader3, sizeof(BitmapHeader), 1, fr);

	printf("Informace o obrazku:\n\n");
	printf("Nazev obrazku: %s\n",SOUBOR);
	printf("Velikost: %d byte\n", fileHeader2.FileSize);
	printf("Rozliseni(px): %d x %d\n",fileHeader3.Width,fileHeader3.Height);
	printf("Offset dat: %d\n",fileHeader2.BitmapOffset);
	printf("Barevna hloubka: %d\n",fileHeader3.Planes);
	printf("Pocet bitu na pixel: %d\n", fileHeader3.BitsPerPixel);

	velikostPole = fileHeader3.Height * fileHeader3.Width / 8;

	pole = (byte*)malloc(velikostPole);
	if (pole == NULL)
	{
		printf("Chyba nedostatek pameti...Program bude ukoncen");
		return -1;
	}

	fseek(fr, fileHeader2.BitmapOffset, 0);
	fread(pole, velikostPole, 1, fr);

	printf("\nVypis pameti:\n");
	PrintMemory(pole, velikostPole);
	printf("\n");
	/*Data v poli po radcich, od spodniho po horni*/	
	for (radek = fileHeader3.Height; radek > 0; radek--)
	{
		prirustek = (fileHeader3.Width / 8)*(radek - 1);
		ukazatelPole = pole + prirustek ;
		for (poziceRadek = 0; poziceRadek < fileHeader3.Width ; poziceRadek++)
		{
			if (*ukazatelPole & maska)
				printf("%c", 219);
			else
				printf("%c", ' ');

				maska >>= 1;
			if (maska ==0)
			{
				ukazatelPole++;
				maska = 0x80;
			}
		}
		printf("\n");
	}


	free((void *)pole);

	printf("\nAutor: Bc. Ladislav Rubas  - E14N0031P\n\n");

	if (0 != (fclose(fr))) 
	{
		printf("Chyba nelze uzavrit soubor..."); 
		(void)getchar(); 
		return -2; 
	}

	return 0;
}

